classification
Title: Enum: revert to 3.9
Type: Stage: patch review
Components: Library (Lib) Versions: Python 3.10
process
Status: open Resolution: fixed
Dependencies: Superseder:
Assigned To: ethan.furman Nosy List: barry, brett.cannon, ethan.furman, pablogsal, pitrou, python-dev, twouters, willingc
Priority: release blocker Keywords: patch

Created on 2021-07-04 01:48 by ethan.furman, last changed 2021-10-21 02:48 by ethan.furman.

Pull Requests
URL Status Linked Edit
PR 27010 merged ethan.furman, 2021-07-04 01:53
PR 27099 merged ethan.furman, 2021-07-12 17:45
PR 27388 merged python-dev, 2021-07-27 15:17
PR 29114 merged ethan.furman, 2021-10-20 23:17
Messages (6)
msg396935 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2021-07-04 01:48
From the SC (was Re: Enum -- last call for comments on 3.10 changes)
--------------------------------------------------------------------
> The Steering Council discussed this topic at our meeting yesterday.  We have some
> discomfort about the changes to Enum’s str and repr in Python 3.10, both in the
> specific changes and in the way the changes were decided on.  No knock on Ethan or
> others who participated in those decisions, it’s just that to us, the changes
> cumulatively feel like they need a more formal, centralized discussion to understand
> all the issues in detail.
> 
> While we’re stopping short of requiring it, the Steering Council strongly suggests that
> for Python 3.10, the changes in Enum’s str and repr be reverted back to the Python 3.9
> behavior, and that a PEP be written for Python 3.11.

The changes were primarily spurred both by the changes to re.RegexFlag and by unfortunate choices made in enum.Flag regarding aliases and iteration that were corrected.

Unfortunately, it proved too difficult to revert the Flag repr() while keeping the corrections, so the entire enum module is being reverted to its 3.9 version.

All the bug-fixes, performance improvements, and other enhancements will have to wait for 3.11.
msg396937 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2021-07-04 04:08
New changeset 9bf7c2d638a582af2444bc864feba13ab8957b68 by Ethan Furman in branch '3.10':
[3.10] bpo-44559: [Enum] revert enum module to 3.9 (GH-27010)
https://github.com/python/cpython/commit/9bf7c2d638a582af2444bc864feba13ab8957b68
msg398303 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2021-07-27 15:20
New changeset 2f54fbafa6481fb10528cb1d3d6b517ca2a4647f by Steffen Zeile in branch 'main':
bpo-44559: [Enum] correct `versionadded` to 3.11 for new features (GH-27388)
https://github.com/python/cpython/commit/2f54fbafa6481fb10528cb1d3d6b517ca2a4647f
msg403863 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2021-10-13 17:43
It seems the revert was not done properly: it removed from 3.10 some bugfixes that had been applied to 3.9 (see issue42248 for an example).
msg403876 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2021-10-13 21:36
Going back through the various bug fixes that got cut from 3.10 to re-add to 3.10.1.
msg404563 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2021-10-21 02:48
New changeset 2a9ab75af32b1ee9f210ae2a0718990687d0f79d by Ethan Furman in branch '3.10':
bpo-44559: [Enum] restore fixes lost in 3.9 reversion (GH-29114)
https://github.com/python/cpython/commit/2a9ab75af32b1ee9f210ae2a0718990687d0f79d
History
Date User Action Args
2021-10-21 02:48:47ethan.furmansetmessages: + msg404563
2021-10-20 23:17:12ethan.furmansetstage: patch review
pull_requests: + pull_request27385
2021-10-13 21:36:36ethan.furmansetmessages: + msg403876
2021-10-13 17:43:54pitrousetstatus: closed -> open

nosy: + pitrou
messages: + msg403863

stage: resolved -> (no value)
2021-07-27 15:20:05ethan.furmansetmessages: + msg398303
2021-07-27 15:17:53python-devsetnosy: + python-dev

pull_requests: + pull_request25922
2021-07-12 17:45:03ethan.furmansetpull_requests: + pull_request25647
2021-07-04 04:09:31ethan.furmansetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2021-07-04 04:08:50ethan.furmansetmessages: + msg396937
2021-07-04 01:53:28ethan.furmansetkeywords: + patch
stage: patch review
pull_requests: + pull_request25570
2021-07-04 01:48:24ethan.furmancreate